# This patch file was generated by NetBeans IDE
# This patch can be applied using context Tools: Apply Diff Patch action on respective folder.
# It uses platform neutral UTF-8 encoding.
# Above lines and this line are ignored by the patching process.
Index: moodle/mod/glossary/formats/continuous/continuous_format.php
--- moodle/mod/glossary/formats/continuous/continuous_format.php Base (1.16)
+++ moodle/mod/glossary/formats/continuous/continuous_format.php Locally Modified (Based On 1.16)
@@ -4,23 +4,25 @@
 
     global $USER;
 
-    echo '<table class="glossarypost continuous" cellspacing="0">';
-    echo '<tr valign="top">';
-    echo '<td class="entry">';
+    echo html_writer::start_tag('div', array('class'=>'glossarypost continuous'));
+
+    echo html_writer::start_tag('div', array('class'=>'entry'));
     glossary_print_entry_approval($cm, $entry, $mode);
     glossary_print_entry_attachment($entry, $cm, 'html', 'right');
-    echo '<div class="concept">';
+    echo html_writer::start_tag('div', array('class'=>'concept'));
     glossary_print_entry_concept($entry);
-    echo '</div> ';
+    echo html_writer::end_tag('div'); // concept
+    echo html_writer::start_tag('div', array('class'=>'definition'));
     glossary_print_entry_definition($entry, $glossary, $cm);
+    echo html_writer::end_tag('div'); // definition
     $entry->alias = '';
-    echo '</td></tr>';
+    echo html_writer::end_tag('div'); // entry
 
-    echo '<tr valign="top"><td class="entrylowersection">';
+    echo html_writer::start_tag('div', array('class'=>'entrylowersection'));
     glossary_print_entry_lower_section($course, $cm, $glossary, $entry, $mode, $hook, $printicons, $aliases);
-    echo '</td>';
-    echo '</tr>';
-    echo "</table>\n";
+    echo html_writer::end_tag('div'); // entrylowersection
+
+    echo html_writer::end_tag('div'); // glossarypost
 }
 
 function glossary_print_entry_continuous($course, $cm, $glossary, $entry, $mode='', $hook='', $printicons=1) {
@@ -34,5 +36,3 @@
     glossary_show_entry_continuous($course, $cm, $glossary, $entry, $mode, $hook, false, false, false);
 
 }
-
-
Index: moodle/mod/glossary/formats/dictionary/dictionary_format.php
--- moodle/mod/glossary/formats/dictionary/dictionary_format.php Base (1.15)
+++ moodle/mod/glossary/formats/dictionary/dictionary_format.php Locally Modified (Based On 1.15)
@@ -4,21 +4,25 @@
 
     global $CFG, $USER;
 
-    echo '<table class="glossarypost dictionary" cellspacing="0">';
-    echo '<tr valign="top">';
-    echo '<td class="entry">';
+    echo html_writer::start_tag('div', array('class'=>'glossarypost dictionary'));
+
+    echo html_writer::start_tag('div', array('class'=>'entry'));
     glossary_print_entry_approval($cm, $entry, $mode);
     glossary_print_entry_attachment($entry, $cm, 'html', 'right');
-    echo '<div class="concept">';
+    echo html_writer::start_tag('div', array('class'=>'concept'));
     glossary_print_entry_concept($entry);
-    echo '</div> ';
+    echo html_writer::end_tag('div'); // concept
+    echo html_writer::start_tag('div', array('class'=>'definition'));
     glossary_print_entry_definition($entry, $glossary, $cm);
-    echo '</td></tr>';
-    echo '<tr valign="top"><td class="entrylowersection">';
+    echo html_writer::end_tag('div'); // definition
+    $entry->alias = '';
+    echo html_writer::end_tag('div'); // entry
+
+    echo html_writer::start_tag('div', array('class'=>'entrylowersection'));
     glossary_print_entry_lower_section($course, $cm, $glossary, $entry, $mode, $hook, $printicons, $aliases);
-    echo '</td>';
-    echo '</tr>';
-    echo "</table>\n";
+    echo html_writer::end_tag('div'); // entrylowersection
+
+    echo html_writer::end_tag('div'); // glossarypost
 }
 
 function glossary_print_entry_dictionary($course, $cm, $glossary, $entry, $mode='', $hook='', $printicons=1) {
Index: moodle/mod/glossary/formats/entrylist/entrylist_format.php
--- moodle/mod/glossary/formats/entrylist/entrylist_format.php Base (1.24)
+++ moodle/mod/glossary/formats/entrylist/entrylist_format.php Locally Modified (Based On 1.24)
@@ -5,22 +5,23 @@
 
     $return = false;
 
-    echo '<table class="glossarypost entrylist" cellspacing="0">';
+    echo html_writer::start_tag('div', array('class'=>'glossarypost entrylist clearfix'));
 
-    echo '<tr valign="top">';
-    echo '<td class="entry">';
     if ($entry) {
+        echo html_writer::start_tag('div', array('class'=>'entry'));
         glossary_print_entry_approval($cm, $entry, $mode);
 
         $anchortagcontents = glossary_print_entry_concept($entry, true);
 
-        $link = "/mod/glossary/showentry.php?courseid={$course->id}&eid={$entry->id}&displayformat=dictionary";
-        $action = new popup_action('click', $link.'&popup=1', 'entry',array('title'=>'entry','width'=>600,'height'=>450));
-
+        $link = new moodle_url('/mod/glossary/showentry.php', array('courseid'=>$course->id, 'eid'=>$entry->id, 'displayformat'=>'dictionary'));
+        $action = new popup_action('click', new moodle_url($link, array('popup'=>1)), 'entry', array('title'=>'entry','width'=>600,'height'=>450));
         $anchor = $OUTPUT->action_link($link, $anchortagcontents, $action);
 
-        echo "<div class=\"concept\">$anchor</div> ";
-        echo '</td><td align="right" class="entrylowersection">';
+        echo html_writer::tag('div', $anchor, array('class'=>'concept'));
+
+        echo html_writer::end_tag('div'); // entry
+        echo html_writer::start_tag('div', array('class'=>'entrylowersection'));
+
         if ($printicons) {
             glossary_print_entry_icons($course, $cm, $glossary, $entry, $mode, $hook,'print');
         }
@@ -30,15 +31,16 @@
             $return = glossary_print_entry_ratings($course, $entry);
             echo '</span>';
         }
-        echo '<br />';
+
+        echo html_writer::end_tag('div'); // entrylowersection
     } else {
-        echo '<div style="text-align:center">';
-        print_string('noentry', 'glossary');
-        echo '</div>';
+        echo html_writer::start_tag('div', array('class'=>'entry'));
+        echo html_writer::tag('div', get_string('noentry','glossary'), array('class'=>'mdl-align'));
+        echo html_writer::end_tag('div'); // entry
     }
-    echo '</td></tr>';
 
-    echo "</table>\n";
+    echo html_writer::end_tag('div'); // glossarypost
+
     return $return;
 }
 
Index: moodle/mod/glossary/styles.css
--- moodle/mod/glossary/styles.css Base (1.4)
+++ moodle/mod/glossary/styles.css Locally Modified (Based On 1.4)
@@ -1,12 +1,14 @@
 /** General Styles **/
-.path-mod-glossary .glossarypost {width: 95%;border-collapse:separate;margin:0px auto;text-align: left;}
+.path-mod-glossary .glossarypost {width: 95%;border-collapse:separate;margin:0.5em auto;text-align: left;}
 .path-mod-glossary .glossarypost.entrylist {border-width:0px;}
-.path-mod-glossary .glossarypost.continuous .concept {display: inline;}
+.path-mod-glossary .glossarypost.entrylist .entry  {float:left;}
+.path-mod-glossary .glossarypost.entrylist .entrylowersection {float:right;text-align:right;}
 .path-mod-glossary .glossarypost .commands {width: 200px;white-space: nowrap;}
 .path-mod-glossary .glossarypost .picture {width: 35px;}
 .path-mod-glossary .glossarypost .entrylowersection .aliases {text-align:center;}
 .path-mod-glossary .glossarypost .entrylowersection .icons {text-align:right;padding-right: 5px;}
 .path-mod-glossary .glossarypost .entrylowersection .ratings {text-align:right;padding-right: 5px;padding-bottom: 2px;}
+.path-mod-glossary .glossarypost .entrylowersection table {width: 100%;margin-bottom:0em;}
 
 .path-mod-glossary .glossarydisplay {margin-left:auto;margin-right:auto;}
 .path-mod-glossary .glossarydisplay .tabs {width: 100%;margin-bottom: 0px;}
@@ -15,8 +17,7 @@
 
 .path-mod-glossary table.glossarypopup {width: 95%;}
 .path-mod-glossary .entrybox, /** Used in tabs.php **/
-.path-mod-glossary table.glossaryapproval,
-.path-mod-glossary .glossarypost .entrylowersection table{width: 100%;margin-bottom:0em;}
\ No newline at end of file
+.path-mod-glossary table.glossaryapproval {width: 100%;margin-bottom:0em;}
\ No newline at end of file
 
 /** Page specific styles **/
 #page-mod-glossary-view .glossarycontrol {float: right;text-align:right;white-space: nowrap;margin: 5px 0;}